<!doctype html>
<html lang="de">
<head>
    <meta charset="utf-8">
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>QuADTool Quickstart Guide and Reference</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link href="https://fonts.googleapis.com/css?family=Nunito+Sans:300,400,600,700,800,900" rel="stylesheet">
    <link rel="stylesheet" href="scribbler-global.css">
    <link rel="stylesheet" href="scribbler-doc.css">
    <link rel="author" href="Florian Dorfhuber florian.dorfhuber@in.tum.de">
    <style>
          img {
            display: block;
            margin-left: auto;
            margin-right: auto;
          }


    </style>
</head>
<body>
<div class="doc__bg"></div>
<nav class="header">
    <h1 class="logo">QuADTool&nbsp;<span class="logo__thin">Doc</span></h1>
    <ul class="menu">
        <div class="menu__item toggle"><span></span></div>
        <li class="menu__item"><a href="https://gitlab.com/live-lab/software/add-tool" class="link link--dark"><i
                class="fa fa-github"></i> Github</a></li>
        <!--<li class="menu__item"><a href="index.html" class="link link--dark"><i class="fa fa-home"></i> Home</a></li>-->
    </ul>
</nav>
<div class="wrapper">
    <aside class="doc__nav">
        <ul>
            <li class="js-btn selected">Schnellstart</li>
            <li class="js-btn">Erste Schritte</li>
            <li class="js-btn">UI</li>
            <li class="js-btn">Dateien</li>
            <li class="js-btn">Operatoren</li>
            <li class="js-btn">Domänen</li>
            <li class="js-btn">Analyse</li>
            <li class="js-btn">Tastenkombinationen</li>
            <li class="js-btn">Integration</li>
            <li class="js-btn">Sicherheit</li>
            <li class="js-btn">Barrierefreiheit</li>
            <li class="js-btn">Plugins</li>
            <li class="js-btn">Bibliotheken</li>
        </ul>
    </aside>
    <article class="doc__content">
        <section class="js-section">
            <h2 class="section__title">Schnellstart</h2>
            <p>Kurzanleitung für die grundlegendsten Funktionen. Weiter unten finden Sie eine vollständige Erklärung für alle Funktionen.</p>
            <h3>Installation</h3>
            <p>Zum Ausführen von QuADTool legen Sie die .jar-Datei von <a href="https://gitlab.com/live-lab/software/add-tool/-/raw/main/release/latest.jar">hier</a> in den Zielordner.
                Starten Sie es dann mit Ihrer installierten Java-Version.
                Alternativ können Sie es als <a href="https://plugins.jetbrains.com/plugin/21844-quadtool">Plugin</a> zu Ihrer IntelliJ-basierten IDE hinzufügen</p>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>
                java -jar quadtool.jar
                PATH_TO_JAVA_BIN -jar quadtool.jar
              </code>
            </pre>
            </div>
            <p><b>HINWEIS:</b> In den meisten Betriebssystemen mit korrekt installierten Java-Versionen
                (mindestens JDK 14) genügt ein Doppelklick auf die .jar-Datei zum
                startet des Editors.</p>

            <h3>Erster Start</h3>
            <img src="quadtool_initial_de.png" alt="Initial setup">
            <p>Beim ersten Start können Sie Ihre <b>Sprache</b> (neue Sprachen können als Plugins hinzugefügt werden)
                und ein Standard-<b>Einstellungsprofil</b> auswählen.
                <br>Sie können auch die automatische Suche nach Analysetools starten.</p>

            <img src="quadtool_tuto_de.png" alt="Tutorial popup">
            <p>Dann zeigt Ihnen ein Leitfaden die wichtigsten Funktionen des Tools.</p>


            <h3>Datei öffnen</h3>
            <img src="quadtool_open_de.png" alt="Open button">
            <p>Um eine Datei zu öffnen, drücken Sie den Öffnen-Button in der Symbolleiste
                oder die Tastenkombination <b>STRG+O</b>. Wählen Sie dann eine
                <b>.dot</b>- oder <b>.xml</b>-Datei aus den unten aufgeführten Standards.
                Wir stellen einige Beispiele im "examples"-Verzeichnis des Tool-Ordners zur Verfügung.<br>
                Die Beispiele können auch über <b>STRG+SHIFT+O</b> geöffnet werden. Die Dateien sind mit der Sprache und der Schwierigkeit versehen.</p>


            <h3>Model bearbeiten</h3>
            <img src="quadtool_example_de.png" alt="Example model">
            <p>Um Knoten zu verschieben, können Sie sie an die neue Position ziehen.
                Durch Ziehen am Textlabel wird eine neue Kante/Verbindung erstellt.
                Durch Drücken von <b>ENTER</b> wird ein Bearbeitungsdialog geöffnet.</p>

            <img src="quadtool_edit_vertex_de.png" alt="Dialog for editing vertices">
            <p>Hier können Sie den Knotentyp, den Namen und andere Eigenschaften ändern.<br>
                Um die Bezeichnung oder den Knotentyp zu ändern, können Sie auch
                <b>mit der rechten Maustaste</b> darauf klicken und die Option im Popup-Menü auswählen. </p>

            <img src="quadtool_leftToolbar_de.png" alt="Left toolbar">
            <p>Neue Knoten können durch Klicken oder Ziehen von Symbolen in der linken Symbolleiste erstellt werden.</p>

            <h3>Analyse</h3>
            <img src="quadtool_run_de.png" alt="Run button">
            <p>Eine einfache Möglichkeit, Ihr Modell zu analysieren, ist die Schaltfläche
                „Ausführen“ in der Symbolleiste. Sie können sich auch das Panel
                am rechten Rand des Fensters ansehen.</p>

            <h3>Speicher/Export</h3>
            <p>Sie können das Modell mit der Speichern-Schaltfläche in der Symbolleiste oder mit <b>STRG+S</b> speichern.
                Um eine Datei in andere Formate zu exportieren,
                können Sie <b>STRG+E</b> oder den Eintrag im <b>Datei</b>-Menü verwenden.</p>
            <hr/>
        </section>

        <section class="js-section">
            <h2 class="section__title">Erste Schritte</h2>
            <h3 >Installation</h3>
            <h4 >Java</h4>
            <p>Eine Java-Installation (JDK 14 oder höher) ist erforderlich,
                um das Tool auszuführen.
                Sie können es <a href="https://openjdk.org/">hier</a> herunterladen.
                Dort sind auch Installationsanweisungen zu finden.</p>
            <h4>QuADTool</h4>
            <!--TODO add correct file link-->
            <p>Zum Ausführen des QuADTool legen Sie die .jar-Datei von der <a href="https://gitlab.com/live-lab/software/add-tool/-/raw/main/release/latest.jar">Download</a>-Seite in den Zielordner.
                <b>HINWEIS:</b> Das Tool und der ausführende Benutzer müssen Schreibrechte in diesem Ordner haben.</p>
            <!--TODO add plugin-->
            <h4>Starten</h4>
            <p>Geben Sie einen der folgenden Befehle in Ihre Shell ein.
                Wenn das jdk als PATH Variable hinterlegt ist, sollte der erste ausreichen.</p>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>
                java -jar quadtool.jar
                PATH_TO_JAVA_BIN -jar quadtool.jar
              </code>
            </pre>
            </div>
            <p><b>HINWEIS:</b> In den meisten Betriebssystemen mit korrekt installierten Java-Versionen (mindestens JDK 14)
                genügt ein Doppelklick auf die .jar-Datei zum Starten des Editors.</p>

            <h4>Plugin</h4>
            <p>QuADTool hat ein IntelliJ-Plug-in, das auf dem <a href="https://plugins.jetbrains.com/plugin/21844-quadtool">Marketplace</a>
                installiert werden kann. Es wird automatisch in Ihrer IDE ausgeführt.</p>
            <hr/>
        </section>

        <section class="js-section">
            <h2 class="section__title">UI</h2>
            <!--<h3 class="section__title">Main window</h3>-->
            <img src="quadtool_overview_de.png" style="width: 60vw;" alt="Initial setup">
            <ol type="1">
                <li>Leinwand: Hier bearbeiten Sie den Graphen, indem Sie die Knoten anordnen.</li>
                <li>Tutorial-Fenster: Beim ersten Start hilft Ihnen die Tour, sich im Tool zurechtzufinden. Sie können die Tour im Hilfe-Element der Menüleiste (8) neu starten</li>
                <li>Obere Symbolleiste: Sie enthält Aktionen zum Öffnen/Speichern von Dateien, Analysieren des Modells, Ändern der Schriftgröße, Ausschneiden, Kopieren, Einfügen und Git (nicht angezeigt)</li>
                <li>Linke Symbolleiste: Bearbeiten Sie Knoten, sortieren Sie das Diagramm oder fügen Sie neue Knoten hinzu, indem Sie auf eine Schaltfläche klicken oder sie auf die Leinwand ziehen.</li>
                <li>Feedback-Bereich: Gibt Ihnen Feedback zu Ihrem Modell in Bezug auf die Struktur oder ein bestimmtes Ausgabeformat.</li>
                <li>Analysebereich: Gibt Daten aus, die durch die Analyse des aktuellen Modells generiert wurden.</li>
                <li>Model-Checker-Bereich: Klicken Sie auf die Schaltfläche „*“, um einen Model-Checker auszuwählen und die Analyse auszuführen. (siehe Abschnitt Analyse)</li>
                <li>Menüleiste: Die meisten Aktionen der Symbolleiste sind hier noch einmal dargestellt. Außerdem finden Sie den Einstellungsdialog im Dateimenü. </li>
            </ol>
        </section>

        <section class="js-section">
            <h2 class="section__title">Dateien</h2>
            <p>QuADTool verwendet eine Vielzahl von Dateien. Dieser Abschnitt gibt Ihnen einen Überblick
                darüber und wann Sie sie verwenden können.
                Über das Plugin-System können die In-/Export-Möglichkeiten erweitert werden.</p>
            <table id="customers">
                <tr>
                    <th>Dateityp</th>
                    <th>Erweiterung</th>
                    <th>Importieren</th>
                    <th>Exportieren</th>
                    <th>Zugehöriges Tool</th>
                </tr>
                <!--&#x2713; Checkmark &#x2718;-->
                <tr>
                    <td>Dot</td>
                    <td>.dot</td>
                    <td><b>&#x2713;</b></td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://graphviz.org/">Graphviz</a></td>
                </tr>
                <tr>
                    <td>DUMP</td>
                    <td>.dump</td>
                    <td><b>&#x2713;</b></td>
                    <td><b>&#x2713;</b></td>
                    <td>QuADTool</td>
                </tr>
                <tr>
                    <td>XML (ADTool)</td>
                    <td>.xml</td>
                    <td><b>&#x2713;</b></td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://satoss.uni.lu/members/piotr/adtool/">ADTool</a></td>
                </tr>
                <tr>
                    <td>PRISM</td>
                    <td>.prism</td>
                    <td>&#x2718;</td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://www.prismmodelchecker.org/games/">PRISM Games</a></td>
                </tr>
                <tr>
                    <td>XML (UPPAAL)</td>
                    <td>.xml/.uppaal.xml</td>
                    <td>&#x2718;</td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://uppaal.org/">UPPAAL</a></td>
                </tr>
                <tr>
                    <td>Modest</td>
                    <td>.modest</td>
                    <td>&#x2718;</td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://www.modestchecker.net/">Modest</a></td>
                </tr>
                <tr>
                    <td>PNG</td>
                    <td>.png</td>
                    <td>&#x2718;</td>
                    <td><b>&#x2713;</b></td>
                    <td>Jedes Bild-Programm</td>
                </tr>
            </table>
            <hr/>

            <h3>Dot</h3>
            <p>Die Dot-Datei definiert Knoten und ihre Verbindungen.
                Das Tool <a href="https://graphviz.org/">Graphviz</a> kann damit Bilddateien generieren.
                Es ist die interne Hauptdatei von QuADTool, da es fast keine Beschränkungen
                in der Menge der gespeicherten Daten oder der Operatoren gibt.</p>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>digraph {
                1 [operator="BE",name="exploit_software",
                distribution="Attacker",probability="1.0",cost="1.0"];
                2 [operator="Not",label="Not"];
                1->2
              }
              </code>
            </pre>
            </div>
            <p>Dieses Beispiel definiert ein ADD mit einem Basis-Ereignis (siehe Abschnitt Operatoren)
                und einem daran angehängten NICHT-Operator.<br>
                <b>HINWEIS:</b> Das Tool fügt viel mehr Daten hinzu. Dies ist das Minimum, damit die Datei eingelesen werden kann.<br>
                <b>HINWEIS:</b> Das Tool speichert Ihren Fortschritt in diesem Format automatisch während der Laufzeit.
                Sie finden den tmp-Ordner im Installationsverzeichnis. </p>
            <hr/>

            <h3>Dump</h3>
            <p>Wollen sie ihre Arbeit speichern und das Modell ist noch nicht gültig, können Sie es als dump speichern.
            Dabei wird einfach nur der aktuelle Zustand gespeichert. Sie können die Dateien über die Datei-Öffnen-Aktion laden.</p>

            <h3>XML (ADTool)</h3>
            <p>Das XML-Format wird von den Spezifikationen des
                <a href="https://satoss.uni.lu/members/piotr/adtool/">ADTool</a> abgeleitet.</p>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <textarea rows="11" cols="40" style="border:none;">
<adtree>
    <node refinement="conjunctive">
        <label>And</label>
        <node refinement="disjunctive">
            <label>Steal laptop</label>
        </node>
        <node refinement="disjunctive">
            <label>Steal password</label>
        </node>
    </node>
</adtree></textarea>
            </pre>
            </div>
            <p>Dieses Beispiel definiert ein ADD mit zwei Basis-Ereignissen, die durch einen Und-Knoten verbunden sind.<br>
                <b>HINWEIS:</b> Das Tool fügt viel mehr Daten hinzu. Dies ist das Minimum, um es einlesen zu können. </p>
            <h4>Einschränkungen</h4>
            <p>Das Format unterstützt nur <b>einen Wurzelknoten</b>.
                Die erlaubten Operatoren sind Und, Oder, Nicht, SUnd, Basis-Ereignis
                (Angreifer, Verteidiger) (siehe Abschnitt Operatoren).
                <br><b>HINWEIS:</b> Sequentielles-Und (SUnd) wird nur in Versionen >=2.0 des ADTool unterstützt.
                Wenn Sie SUnd verwenden, darf das Modell keine
                Nicht- und Verteidiger-Knoten enthalten.</p>
            <h4>Analyse</h4>
            <p>QuADTool exportiert automatisch Daten zur Analyse von Erfolgswahrscheinlichkeit und Mindestkosten (siehe Domänen
                Abschnitt).
                Das ADTool bietet weitere Domänen, die im Tool hinzugefügt werden können. Ein Beispiel ist die Erreichbarkeit von einem
                Ziel in k Zeiteinheiten.
                Das Handbuch kann <a href="https://satoss.uni.lu/members/piotr/adtool/manual.pdf">hier</a> heruntergeladen werden.
            </p>
            <hr/>

        <h3>PRISM</h3>
        <p>Das PRISM-Format kann verwendet werden, um Modelle mit <a href="https://www.prismmodelchecker.org/games/">PRISM zu analysieren
            Spiele</a>.</p>
        <details>
            <summary>Beispiel Datei</summary>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>
smg

player attacker
    [a1]
endplayer

player defender
    [a2], [default]
endplayer

module ADD
turn : [0..1] init 0;
v0 : [-1..1] init 0;
v1 : [-1..1] init 0;
v2 : [-1..1] init 0;
[default] (turn=1 & v0=0 & v1=1 & v2=0) -> 1.0:(turn'=0) & (v1'=1);
[a2] (turn=1 & v0=0 & v1=1 & v2=0) -> 1.0:(turn'=0) & (v2'=1) & (v1'=1) & (v0'=1);
[a1] (turn=0 & v0=0 & v1=0 & v2=0) -> 1.0:(turn'=1) & (v1'=1);
endmodule

label "success" = v0=1;
label "fail" = v0=-1;

rewards "costAttacker"
[a1]true : 1/1;
endrewards
</code>
            </pre>
            </div>
            <p>Dieses Beispiel stellt ein ADD mit zwei Basis-Ereignissen dar, eines für jeden Spieler, die durch einen Und-Knoten verbunden sind. </p>
        </details>
        <h4>Einschränkungen</h4>
        <p>Das Format erlaubt alle Operatoren außer Zurücksetzten.
            Trotz der Erlaubnis ist es sinnvoll, mindestens eine Aktion pro Spieler zu haben.
            Andernfalls könnte die Analyse sinnlos sein.
        <h4>Analyse</h4>
        <p>Die bereitgestellten Eigenschaften für PRISM erlauben es, die Erfolgswahrscheinlichkeit für einen Angreifer im Zwei-Spieler-Spiel zu analysieren.
            Dadurch können sich die Ergebnisse von anderen Tools unterscheiden, da die Spieler abwechselnd ziehen.
        <br><b>HINWEIS:</b> Das Analysieren von Modellen mit mehr als 20 Knoten wird langsam.
        Mit etwa 30 Knoten oder mehr wird es vielleicht nie fertig.</p>
        <hr/>

        <h3>XML (UPPAAL)</h3>
        <p>Dieses XML-Format kann vom <a href="https://uppaal.org/">UPPAAL</a> Model-Checker
            verwendet werden. Es stützt sich auf Automaten für jeden Knoten und Nachrichten,
            die an die Nachfolgeknoten/-automaten gesendet werden.
            Alle Wurzelknoten sind mit einem gewinnenden Automaten verbunden.</p>
        <details>
            <summary>Beispiel Datei</summary>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <textarea rows="329" cols="101" style="border:none;">
<nta>
<declaration>
int update_And0=0,state_And0=0,timestamp_And0=0;
int update_BEPlayer1=0,state_BEPlayer1=0,timestamp_BEPlayer1=0;
int update_BEPlayer2=0,state_BEPlayer2=0,timestamp_BEPlayer2=0;
int steps=1;
double costvar=0.0;
urgent broadcast chan propagate;
</declaration>

<template>
	<name>And0</name>
<declaration>void updateSuccs(){
}
void updateSelf(int stat){
state_And0=stat;
timestamp_And0=steps;
steps++;
}</declaration>
	<location id="id0" x="0" y="0">
<name x="0" y="0">INIT</name>
</location>
	<location id="id1" x="1200" y="210">
<name x="1200" y="210">FAILED</name>
</location>
	<location id="id2" x="1200" y="-150">
<name x="1200" y="-150">TRUE</name>
</location>
	<location id="id3" x="1200" y="0">
<name x="1200" y="0">UNDECIDED</name>
</location>
	<location id="id4" x="-100" y="0"></location>
	<init ref="id0"/>
	<transition>
		<source ref="id4"/>
		<target ref="id0"/>
		<label kind="guard" x="-100" y="30">update_And0==1</label>
		<label kind="synchronisation" x="-100" y="60">propagate!</label>
		<label kind="assignment" x="-100" y="90">update_And0=0</label>
	</transition>
	<transition>
		<source ref="id1"/>
		<target ref="id4"/>
		<label kind="synchronisation" x="1200" y="240">propagate!</label>
		<label kind="assignment" x="1200" y="270">updateSuccs()</label>
		<nail x="1200" y="310"/>
		<nail x="-100" y="310"/>
	</transition>
	<transition>
		<source ref="id2"/>
		<target ref="id4"/>
		<label kind="synchronisation" x="1400" y="-150">propagate!</label>
		<label kind="assignment" x="1400" y="-120">updateSuccs()</label>
		<nail x="1400" y="-150"/>
		<nail x="1400" y="310"/>
		<nail x="-100" y="310"/>
	</transition>
	<transition>
		<source ref="id3"/>
		<target ref="id4"/>
		<label kind="synchronisation" x="1300" y="0">propagate!</label>
		<label kind="assignment" x="1300" y="30">updateSuccs()</label>
		<nail x="1300" y="0"/>
		<nail x="1300" y="310"/>
		<nail x="-100" y="310"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id2"/>
		<label kind="synchronisation" x="180" y="-150">propagate!</label>
		<label kind="guard" x="300" y="-150">state_BEPlayer1==1&amp;&amp;state_BEPlayer2==1</label>
		<label kind="assignment" x="30" y="-150">state_And0=1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="-150"/>
		<nail x="1170" y="-150"/>
		<nail x="1170" y="-150"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="210">propagate!</label>
		<label kind="guard" x="300" y="210">state_BEPlayer1==1&amp;&amp;state_BEPlayer2==-1</label>
		<label kind="assignment" x="30" y="210">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="210"/>
		<nail x="1170" y="210"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="180">propagate!</label>
		<label kind="guard" x="300" y="180">state_BEPlayer1==-1&amp;&amp;state_BEPlayer2==1</label>
		<label kind="assignment" x="30" y="180">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="180"/>
		<nail x="1170" y="180"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="150">propagate!</label>
		<label kind="guard" x="300" y="150">state_BEPlayer1==-1&amp;&amp;state_BEPlayer2==-1</label>
		<label kind="assignment" x="30" y="150">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="150"/>
		<nail x="1170" y="150"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="120">propagate!</label>
		<label kind="guard" x="300" y="120">state_BEPlayer1==-1&amp;&amp;state_BEPlayer2==0</label>
		<label kind="assignment" x="30" y="120">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="120"/>
		<nail x="1170" y="120"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="90">propagate!</label>
		<label kind="guard" x="300" y="90">state_BEPlayer1==0&amp;&amp;state_BEPlayer2==-1</label>
		<label kind="assignment" x="30" y="90">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="90"/>
		<nail x="1170" y="90"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id3"/>
		<label kind="synchronisation" x="180" y="0">propagate!</label>
		<label kind="guard" x="300" y="0">state_BEPlayer1==1&amp;&amp;state_BEPlayer2==0</label>
		<label kind="assignment" x="30" y="0">state_And0=0</label>
		<nail x="30" y="0"/>
		<nail x="30" y="0"/>
		<nail x="1170" y="0"/>
		<nail x="1170" y="0"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id3"/>
		<label kind="synchronisation" x="180" y="-30">propagate!</label>
		<label kind="guard" x="300" y="-30">state_BEPlayer1==0&amp;&amp;state_BEPlayer2==1</label>
		<label kind="assignment" x="30" y="-30">state_And0=0</label>
		<nail x="30" y="0"/>
		<nail x="30" y="-30"/>
		<nail x="1170" y="-30"/>
		<nail x="1170" y="0"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id3"/>
		<label kind="synchronisation" x="180" y="-60">propagate!</label>
		<label kind="guard" x="300" y="-60">state_BEPlayer1==0&amp;&amp;state_BEPlayer2==0</label>
		<label kind="assignment" x="30" y="-60">state_And0=0</label>
		<nail x="30" y="0"/>
		<nail x="30" y="-60"/>
		<nail x="1170" y="-60"/>
		<nail x="1170" y="0"/>
	</transition>
</template>
<template>
	<name>BEPlayer1</name>
<declaration>void updateSuccs(){
update_And0=1;
}
void updateSelf(int stat){
state_BEPlayer1=stat;
timestamp_BEPlayer1=steps;
steps++;
costvar=costvar+1.0;
}</declaration>
	<location id="id5" x="0" y="0">
<name x="0" y="0">INIT</name>
</location>
	<location id="id6" x="400" y="-100">
<name x="400" y="-100">SUCCESS</name>
</location>
	<location id="id7" x="400" y="100">
<name x="400" y="100">FAILED</name>
</location>
	<location id="id8" x="600" y="-200"></location>
	<branchpoint id="id9" x="200" y="0"></branchpoint>
	<init ref="id5"/>
	<transition>
		<source ref="id5"/>
		<target ref="id9"/>
		<label kind="synchronisation" x="30" y="0">propagate!</label>
		<label kind="assignment" x="30" y="30">state_BEPlayer1=0</label>
	</transition>
	<transition>
		<source ref="id9"/>
		<target ref="id6"/>
		<label kind="probability" x="200" y="-100">1000000</label>
		<label kind="assignment" x="200" y="-70">updateSelf(1)</label>
		<nail x="200" y="-100"/>
	</transition>
	<transition>
		<source ref="id6"/>
		<target ref="id8"/>
		<label kind="synchronisation" x="430" y="-130">propagate!</label>
		<label kind="assignment" x="430" y="-160">updateSuccs()</label>
		<nail x="600" y="-100"/>
	</transition>
	<transition>
		<source ref="id7"/>
		<target ref="id8"/>
		<label kind="synchronisation" x="430" y="70">propagate!</label>
		<label kind="assignment" x="430" y="40">updateSuccs()</label>
		<nail x="600" y="100"/>
	</transition>
	<transition>
		<source ref="id8"/>
		<target ref="id5"/>
		<label kind="guard" x="0" y="-200">update_BEPlayer1==1</label>
		<label kind="synchronisation" x="0" y="-170">propagate!</label>
		<label kind="assignment" x="0" y="-140">update_BEPlayer1=0</label>
		<nail x="0" y="-200"/>
	</transition>
</template>
<template>
	<name>BEPlayer2</name>
<declaration>void updateSuccs(){
update_And0=1;
}
void updateSelf(int stat){
state_BEPlayer2=stat;
timestamp_BEPlayer2=steps;
steps++;
costvar=costvar+1.0;
}</declaration>
	<location id="id10" x="0" y="0">
<name x="0" y="0">INIT</name>
</location>
	<location id="id11" x="400" y="-100">
<name x="400" y="-100">SUCCESS</name>
</location>
	<location id="id12" x="400" y="100">
<name x="400" y="100">FAILED</name>
</location>
	<location id="id13" x="600" y="-200"></location>
	<branchpoint id="id14" x="200" y="0"></branchpoint>
	<init ref="id10"/>
	<transition>
		<source ref="id10"/>
		<target ref="id14"/>
		<label kind="synchronisation" x="30" y="0">propagate!</label>
		<label kind="assignment" x="30" y="30">state_BEPlayer2=0</label>
	</transition>
	<transition>
		<source ref="id14"/>
		<target ref="id11"/>
		<label kind="probability" x="200" y="-100">1000000</label>
		<label kind="assignment" x="200" y="-70">updateSelf(1)</label>
		<nail x="200" y="-100"/>
	</transition>
	<transition>
		<source ref="id11"/>
		<target ref="id13"/>
		<label kind="synchronisation" x="430" y="-130">propagate!</label>
		<label kind="assignment" x="430" y="-160">updateSuccs()</label>
		<nail x="600" y="-100"/>
	</transition>
	<transition>
		<source ref="id12"/>
		<target ref="id13"/>
		<label kind="synchronisation" x="430" y="70">propagate!</label>
		<label kind="assignment" x="430" y="40">updateSuccs()</label>
		<nail x="600" y="100"/>
	</transition>
	<transition>
		<source ref="id13"/>
		<target ref="id10"/>
		<label kind="guard" x="0" y="-200">update_BEPlayer2==1</label>
		<label kind="synchronisation" x="0" y="-170">propagate!</label>
		<label kind="assignment" x="0" y="-140">update_BEPlayer2=0</label>
		<nail x="0" y="-200"/>
	</transition>
</template>
<template>
	<name>Won</name>
	<location id="id15" x="0" y="0"></location>
	<location id="id16" x="-400" y="150">
<name x="-400" y="150">Success</name>
</location>
	<location id="id17" x="400" y="150">
<name x="400" y="150">Failed</name>
</location>
	<init ref="id15"/>
	<transition>
		<source ref="id15"/>
		<target ref="id16"/>
		<label kind="synchronisation" x="-220" y="30">propagate!</label>
		<label kind="guard" x="-370" y="30">state_And0==1</label>
		<nail x="0" y="30"/>
		<nail x="-400" y="30"/>
	</transition>
	<transition>
		<source ref="id15"/>
		<target ref="id17"/>
		<label kind="synchronisation" x="180" y="30">propagate!</label>
		<label kind="guard" x="30" y="30">state_And0==-1</label>
		<nail x="0" y="30"/>
		<nail x="400" y="30"/>
	</transition>
</template>
<system>
system And0,BEPlayer1,BEPlayer2,Won;
</system>
<queries>
		<query>
			<formula>Pr[#&lt;=1000000](&lt;&gt; Won.Success)
			</formula>
			<comment>
			</comment>
		</query>
		<query>
			<formula>Pr[#&lt;=1000000](&lt;&gt; Won.Failed)
			</formula>
			<comment>
			</comment>
		</query>
</queries>
</nta>
</textarea>
            </pre>

                <p>Dieses Beispiel definiert ein ADD mit zwei Basis-Ereignissen, die durch einen Und-Knoten verbunden sind.</p>
            </div>
        </details>

        <h4>Einschränkungen</h4>
        <p>Das Format unterstützt keine zeitgesteuerte Analyse. Daher werden Modelle, die zeitgesteuerte Basisereignisse verwenden, möglicherweise nicht richtig ausgewertet.
            Es gibt keine weiteren Einschränkungen bei der Wahl der Operatoren. Der Export wurde an Modellen mit über 100 getestet
            Knoten.</p>
        <h4>Analyse</h4>
        <p>QuADTool exportiert automatisch Daten zur Analyse der Erfolgswahrscheinlichkeit.
            Komplexere Analysen können den Dateien manuell hinzugefügt werden.</p>
        <hr/>


        <h3>Modest</h3>
        <p>Das Modest-Format kann vom <a href="https://www.modestchecker.net/">Modest</a>
            Model Checker verwendet werden. Modest kann die Datei auch in das Jani-Format umwandeln.</p>

        <details>
            <summary>Beispiel Datei</summary>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>
bool wantToSchedule=false;
real epsilon = 0.00001;
action propagate;
action resetsDone;
action triggersDone;

real globalCosts= 0;

int state=0;
property P_won = Pmin(<> (state==1));
property P_los = Pmin(<> (state==-1));
int attack_state=0;
int def_state=0;
property Att_won = Pmin(<> (attack_state==1 && def_state!=1 ));
property Def_won = Pmin(<> (def_state==1 && attack_state!=1));
property Both_won = Pmin(<> (def_state==1 && attack_state==1));
property None_won = Pmin(<> (def_state!=1 && attack_state!=1));
action ttAnd0;
action ffAnd0;
action uuAnd0;

action ttBETime1;
action ffBETime1;
action uuBETime1;
action scheduleBETime1;

action ttBETime2;
action ffBETime2;
action uuBETime2;
action scheduleBETime2;

process Controller(){
bool canPropagate = false;
bool doBreak = false;

urgent(true) propagate;
do{
  ::urgent(true) triggersDone {= doBreak=false =};
    urgent(true) resetsDone;
     when(wantToSchedule) urgent(wantToSchedule) propagate {= wantToSchedule=false =}
  }
    }
process And0(){
do{

  ::alt{
    ::ttBETime1;
      alt{
        ::ttBETime2; urgent(true) ttAnd0{= state = 1, attack_state = 1 =}
        ::ffBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime2; urgent(true) uuAnd0
      }
    ::ffBETime1;
      alt{
        ::ttBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::ffBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
      }
    ::uuBETime1;
      alt{
        ::ttBETime2; urgent(true) uuAnd0
        ::ffBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime2; urgent(true) uuAnd0
      }
    ::ttBETime2;
      alt{
        ::ttBETime1; urgent(true) ttAnd0{= state = 1, attack_state = 1 =}
        ::ffBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime1; urgent(true) uuAnd0
      }
    ::ffBETime2;
      alt{
        ::ttBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::ffBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
      }
    ::uuBETime2;
      alt{
        ::ttBETime1; urgent(true) uuAnd0
        ::ffBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime1; urgent(true) uuAnd0
      }
  }
}
}


process BETime1(){
clock c;
real tp;
urgent(true) tau {= tp=, c=0 =};
do{
  alt{
    ::when(c<=tp+epsilon) propagate; urgent(true) uuBETime1
    ::when(c>=tp) urgent(c>=tp) tau {= wantToSchedule=true, globalCosts+=1.0 =};
      palt{
        :1.0:do{urgent(true) propagate;
          urgent(true) ttBETime1}
        :1-1.0:do{urgent(true) propagate;
          urgent(true) ffBETime1}
      }
}
}
}


process BETime2(){
clock c;
real tp;
urgent(true) tau {= tp=, c=0 =};
do{
  alt{
    ::when(c<=tp+epsilon) propagate; urgent(true) uuBETime2
    ::when(c>=tp) urgent(c>=tp) tau {= wantToSchedule=true, globalCosts+=1.0 =};
      palt{
        :1.0:do{urgent(true) propagate;
          urgent(true) ttBETime2}
        :1-1.0:do{urgent(true) propagate;
          urgent(true) ffBETime2}
      }
}
}
}

par{::Controller()::And0()::BETime1()::BETime2()}
</code>
            </pre>
            </div>
            <p>Dieses Beispiel stellt ein ADD mit zwei Basis-Ereignissen dar, die durch Zeit
                ausgelöst und durch einen And-Knoten verbunden sind. </p>
        </details>
        <h4>Einschränkungen</h4>
        <p>Das Format ist für die Zeitanalyse konzipiert. Daher empfehlen wir,
            nur zeitgesteuerte Basis-Ereignisse zu verwenden.</p>
        <h4>Analyse</h4>
        <p>QuADTool exportiert automatisch Daten zur Analyse der Erfolgswahrscheinlichkeit.
            Komplexere Analysen können manuell zu den Dateien hinzugefügt werden.</p>
        <hr/>
        </section>


        <section class="js-section">
            <h2 class="section__title">Operatoren</h2>
            <p>Dieser Abschnitt listet alle verfügbaren Operatoren mit ihrer Bedeutung und Beispielen auf.
                Jeder Knoten kann sich in drei Zuständen befinden. Er kann wahr, falsch oder unentschieden sein.
            </p>

            <h3>Basis-Ereignis [engl. Basic Event]</h3>
            <p>Es gibt drei Arten von Basis-Ereignissen. Sie können entweder einem Spieler, <b>Angreifer</b> oder <b>Verteidiger</b> oder der <b>Zeit</b> gehören.<br>
                Verteidiger-Maßnahmen müssen die Sicherheit nicht verbessern.
                Wenn der Verteidiger eine Richtlinie für schwache Passwörter verwendet,
                wird dies nicht von einem Angreifer getan, aber erhöht die Wahrscheinlichkeit eines erfolgreichen Angriffs.<br>
                Zeitgesteuerte Ereignisse können ohne aktive menschliche Interaktion stattfinden. Ein Beispiel ist die Korrosion eines mechanischen Teils im Laufe der Zeit.</p>

            <h3>Und [engl. And]</h3>
            <p>Der Und-Operator erfordert, dass alle mit ihm verbundenen Knoten erfolgreich sind. Zum Beispiel muss man sich Zugang zu einem Zielcomputer verschaffen und das Passwort bekommen.</p>
            <h3>Sequentielles-Und (Sund) [engl. SAnd]</h3>
            <p>Der SUnd-Operator erfordert, dass alle mit ihm verbundenen Knoten der Reihe nach erfolgreich sind.
                Zum Beispiel muss man das Tor zum Grundstück durchschreiten, bevor man die Gebäudetür öffnet.</p>

            <h3>Oder [engl. Or]</h3>
            <p>Der Oder-Operator erfordert, dass mindestens ein mit ihm verbundener Knoten erfolgreich ist.
                Zum Beispiel kann man entweder die Vorder- oder die Hintertür eines Gebäudes benutzen, um es zu betreten.</p>
            <h3>Sequentielles Oder (SOder) [engl. SOr]</h3>
            <p>Der SOder-Operator erfordert, dass mindestens ein mit ihm verbundener Knoten erfolgreich ist.
                Aber die Gescheiterten müssen der Reihe nach scheitern.
                Zum Beispiel muss man zuerst die PIN eines Mobiltelefons falsch eingeben, bevor man eine PUK eingibt.</p>


            <h3>Nicht [engl. Not]</h3>
            <p>Der Nicht-Operator ist ein Unary-Operator. Er erlaubt nur einen Vorgänger.
                Der Operator ist wahr, wenn der Vorgänger falsch ist. Er ist unentschieden, wenn der Vorgänger unentschieden ist.
                Beispielsweise darf ein Zielsystem nicht abgeschaltet sein, um einen Angriff zu ermöglichen.</p>
            <h3>Nicht versucht (Nat) [engl. Nat/Ivr]</h3>
            <p>Der Nat-Operator ist ein Unary-Operator. Es erlaubt nur einen Vorgänger.
                Der Operator ist wahr, wenn der Vorgänger unentschieden ist. Ändert sich die Bewertung des Vorgängers, wird der Nat-Operator falsch.
                Beispielsweise erfordert ein Angriff, dass der Verteidiger nicht versucht hat, das Gerät vom LAN-Netzwerk zu trennen.</p>
            <h3>Nicht wahr [engl. Not true]</h3>
            <p>Der "Nicht wahr"-Operator ist eine Kombination aus Nicht und Nat.
                Der Operator ist wahr, wenn der Vorgänger unentschieden oder falsch ist.
                Ändert sich die Bewertung des Vorgängers auf wahr, wird der "Nicht wahr"-Operator falsch.
                Beispielsweise möchte ein Angreifer, dass das Sicherheitssystem entweder nicht gestartet wird oder der Start fehlgeschlagen ist.</p>


            <h3>Kosten [engl. Cost]</h3>
            <p>Der Kosten-Operator fungiert als Beschränkung für Kosten im Teilbaum.
                Der Operator ist wahr, wenn alle Bedingungen erfüllt sind, und falsch, wenn mindestens eine nicht erfüllt ist.
                Zum Beispiel, wenn ein Unternehmen nur begrenzte Mittel hat, die in seine Sicherheitsinfrastruktur investiert werden können.</p>
            <h3>Auslöser [engl. Trigger]</h3>
            <p>Trigger-Operator kann mit Basis-Ereignissen verbunden werden.
                Wenn es als wahr ausgewertet wird, gibt es den Spielern die Möglichkeit, die verbundenen Ereignisse zu verwenden.
                Zum Beispiel löst ein in der Öffentlichkeit stehendes Auto die Möglichkeit aus, es zu stehlen, ohne eine Garage zu betreten.</p>
            <h3>Zurücksetzen [engl. Reset]</h3>
            <p>Der Reset-Operator setzt die verbundenen Basisereignisse auf unentschieden.
                Dadurch werden auch ihre Nachfolgeknoten neu bewertet.
                Zum Beispiel wird das Neustarten eines Systems die Verbindung zum Angreifer
                trennen. Damit wird es für ihn notwendig es erneut zu versuchen.</p>
        </section>

        <section class="js-section">
            <h2 class="section__title">Domänen</h2>
            <p>Dieser Abschnitt listet alle verfügbaren Domänen für die Analyse auf. Sie basieren auf den drei unterstützten Datentypen.
                Neue Analysen können als Plugin hinzugefügt werden.</p>

            <h3>Verfügbare Daten</h3>
            <img src="quadtool_edit_vertex_pac_de.png" alt="Dialog bearbeiten">
            <p>Das QuADTool kann Daten für jedes Basis-Ereignis speichern.
                Dazu gehören eine Fehlerwahrscheinlichkeit, die Kosten des Versuchs, die Verzögerung, die durch den Versuch des Ereignisses verursacht wird.
            </p>
            <img src="quadtool_domain_edit_de.png" alt="Domain bearbeiten">
            <p>
                Sie können den Inhalt im Bearbeitungsdialog bearbeiten.
                Außerdem ermöglicht das Analysefeld auf der rechten Seite die gleichzeitige Bearbeitung aller Basis-Ereignis-Daten einer Domain.
                Die anderen Werte werden dann automatisch berechnet.
            </p>

            <h3>Beste Erfolgswahrscheinlichkeit</h3>
            <p>Diese Domain untersucht die Erfolgswahrscheinlichkeit. So können Sie analysieren, wie wahrscheinlich ein optimaler Angriff erfolgreich ist.</p>
            <h3>Minimale Kosten</h3>
            <p>Diese Domain berechnet die niedrigsten Kosten, die ein Angreifer für einen erfolgreichen Angriff aufwenden müsste.</p>
            <h3>Minimale Verzögerung</h3>
            <p>Diese Domain berechnet die niedrigste Verzögerung, die ein Angreifer für einen erfolgreichen Angriff aufwenden müsste.
                Also, wie schnell ein Angriff zwischen Start und Erfolg sein könnte.</p>
            <h3>Wahrscheinlich-ungefähr-richtig [engl. Probably-Approximately-Correct](PAC)</h3>
            <p>
                Alle Werte können als wahrscheinlich-ungefähr-korrekte (PAC)-Werte gespeichert werden. Dies kann als Konfidenzintervall gesehen werden.
                Die Wahrscheinlichkeit &delta; ist 1-&alpha;. &epsilon; ist der Abstand vom Mittelwert für die Grenze.
                PAC-Daten können z.B. über die ARIMA (Zeitreihen Analyse), Gauß'sche Analyse im Bearbeitungsdialog generiert werden.
                Dafür können die Daten als CSV-Datei importiert werden (markiert durch den orangen Kreis).<br>
                <b>HINWEIS:</b> PAC ist standardmäßig nur in den Experteneinstellungen aktiviert. Es kann in den Einstellungen aktiviert werden.</p>

        </section>
        <section class="js-section">
            <h2 class="section__title">Analyse</h2>

            <h3>Intern</h3>
            <p>Das Tool analysiert automatisch die oben aufgeführten Domains im Analysebereich auf der rechten Seite des Bildschirms.</p>
            <img src="quadtool_analysis_de.png" alt="Analysebereich">
            <p><b>HINWEIS:</b> Im Anfängerprofil wird nur die Wahrscheinlichkeit angezeigt. Sie können die anderen in den Einstellungen aktivieren.</p>

            <h3>Extern</h3>
            <p>Externe Analysen können über die Schaltfläche "Ausführen" oder das Model-Checker-Panel in der unteren rechten Ecke durchgeführt werden.</p>
            <img src="quadtool_checkers_de.png" alt="Checker-Einstellungen">
            <p>Durch Klicken auf die Sternschaltfläche im Checker-Feld wird der Einstellungsdialog geöffnet.
                Hier können Sie die allgemeinen Einstellungen für das Model-Checking überprüfen und ein Tool auswählen.
                Um ein anderes Tool zu verwenden, müssen Sie die ausführbare Datei auf Ihrer Festplatte auswählen.
                Für UPPAAL und ADTool werden spezielle Versionen benötigt, da andere keine Kommando-Zeilen-Anbindung haben.
            </p>
            <ul>
                <li>ADTool (Version >=2.0)</li>
                <li>UPPAAL verifiziert</li>
            </ul>
            <p>
            Die Parameter sind vorbereitet, können aber beliebig verändert werden. Die Platzhalter haben folgende Bedeutung.
            </p>
            <ul>
                <li>[tool] &#8594; Pfad zum Tool</li>
                <li>[input] &#8594; die temporäre Datei, die von QuADTool exportiert wird</li>
                <li>[output] &#8594; die temporäre Datei, die von der Ausgabe des Model-Checkers generiert wurde.</li>
            </ul>
            <p>
            Nachdem Sie auf "Speichern" geklickt haben, wird das Modell analysiert und die Ausgabe wird in einem neuen Tab angezeigt.
            </p>

        </section>

        <section class="js-section">
            <h2 class="section__title">Tastenkombinationen</h2>
            <table>
                <tr>
                    <th>Tasten</th>
                    <th>Aktion</th>
                </tr>
                <tr>
                    <td>STRG+N</td>
                    <td>Neue leere Datei öffnen</td>
                </tr>
                <tr>
                    <td>STRG+S</td>
                    <td>Aktuelle Datei speichern</td>
                </tr>
                <tr>
                    <td>STRG+UMSCHALT+S</td>
                    <td>Aktuelle Datei nach Auswahl einer Zieldatei speichern.</td>
                </tr>
                <tr>
                    <td>STRG+O</td>
                    <td>Datei öffnen</td>
                </tr>
                <tr>
                    <td>STRG+SHIFT+O</td>
                    <td>Beispiel Datei öffnen</td>
                </tr>
                <tr>
                    <td>STRG+E</td>
                    <td>Datei exportieren</td>
                </tr>
                <tr>
                    <td>STRG+R</td>
                    <td>Datei ausführen</td>
                </tr>
                <tr>
                    <td>STRG+Z</td>
                    <td>Letzte Aktion rückgängig machen</td>
                </tr>
                <tr>
                    <td>STRG+Y</td>
                    <td>Eine rückgängig gemachte Aktion wiederherstellen</td>
                </tr>
                <tr>
                    <td>STRG+C</td>
                    <td>Auswahl kopieren</td>
                </tr>
                <tr>
                    <td>STRG+X</td>
                    <td>Auswahl ausschneiden</td>
                </tr>
                <tr>
                    <td>STRG+V</td>
                    <td>Auswahl einfügen</td>
                </tr>
                <tr>
                    <td>STRG+UMSCHALT+O</td>
                    <td>Modell sortieren</td>
                </tr>
                <tr>
                    <td>F1</td>
                    <td>Hilfefenster öffnen</td>
                </tr>
                <tr>
                    <td>Eingabe</td>
                    <td>Ausgewählten Knoten bearbeiten</td>
                </tr>
            </table>
        </section>


        <section class="js-section">
            <h2 class="section__title">Integration</h2>

            <h3>GIT</h3>
            <ul>
                <li>QuADTool erkennt, ob sich die aktuelle Datei in einem GIT-Repository befindet.</li>
                <li>Sie werden gefragt, ob Sie die Datei beim Speichern dem Repository hinzufügen möchten (falls sie nicht bereits hinzugefügt wurde).</li>
                <li>Sie können auch von der Benutzeroberfläche pullen, committen und pushen.</li>
                <li>Bei Bedarf fragt das Tool per Push nach Ihren Zugangsdaten.
                    Zugangsdaten werden nur dauerhaft gespeichert, wenn sie im Einstellungsdialog hinzugefügt werden.</li>
                <li>Anforderungen, die ein Modell beim commit erfüllen muss, können in die ".quadtool"-Datei im Stammverzeichnis des Repositorys geschrieben werden.
                    <br>Sie können die Anforderungen auch über einen Eintrag in der Menüleiste bearbeiten</li>
            </ul>
            <p>
            <b>HINWEIS:</b> GIT-Optionen sind nur sichtbar, wenn ein Repository erkannt wird.</p>


            <h3>ATbest</h3>
            <p>QuADTool wurde in einer Forschungsumgebung entwickelt. Wir würden uns freuen, wenn Sie unser Anliegen durch die Einsendung Ihrer Modelle unterstützen.
                Da wir nur die Struktur benötigen, werden alle Knoten Namen entfernt. Dies gewährleistet die Vertraulichkeit des Sicherheitssystems.
                Sie können das Modell hochladen, indem Sie auf die Cloud-Schaltfläche in der oberen Symbolleiste klicken. Beim ersten Mal werden Sie aufgefordert, einige Informationen über sich einzugeben.
                Nach dem Absenden erhalten Sie einen Token per E-Mail. Sie können sich damit alle anderen Modelle in der Datenbank ansehen und herunterladen.</p>


            <h3>IntelliJ</h3>
            <p>Wir haben ein Plugin für die IntelliJ-Plattform entwickelt, mit dem Sie ADD-Dateien in Ihrem Projekt generieren und bearbeiten können.
                Es fügt eine Option in Ihrem "Tool"-Menü und Ihrer Symbolleiste hinzu.<br>
                Sie können auch xml- oder dot-Dateien in Ihrer IDE bearbeiten und in QuADTool visualisieren.</p>
        </section>

        <section class="js-section">
            <h2 class="section__title">Sicherheit</h2>
            <p>QuADTool unterstützt sowohl symmetrische (AES) als auch asymmetrische (RSA) Verschlüsselung.
                In den Einstellungen können Sie einen privaten Schlüssel und einen öffentlichen Schlüssel hinterlegen.
                Verschlüsselte private Schlüssel werden unterstützt. Sie werden jedes Mal nach der Passphrase gefragt, wenn der Schlüssel benötigt wird.
                Die symmetrische Verschlüsselung erfolgt über ein Passwort, das Sie beim Speichern eingeben.
                Sie können die Verschlüsselungs-/Entschlüsselungsmethode im Dateiauswahldialog auswählen.</p>
        </section>

            <section class="js-section">
                <h2 class="section__title">Barrierefreiheit</h2>
                <p>Wir hoffen, dass QuADTool die Nutzung für jedermann ermöglicht.
                    Die Farbzusammenstellung haben wir mit Color Oracle für Windows getestet.
                    Es können aber auch andere Farben eingestellt werden.
                    Wir haben die Nutzung mit dem Screenreader NVDA getestet.
                    Wenn Sie Probleme mit diesen Funktionen haben, können Sie sich gerne an uns wenden.</p>
            </section>
            <section class="js-section">
                <h2 class="section__title">Plugins</h2>
                <p>Sie können die Funktionalität von QuADTool erweitern, indem Sie Plugins schreiben.
                    Implementieren Sie daher die entsprechende Schnittstelle und legen Sie die JAR-Datei in einem Ordner namens plugins im Tool-Verzeichnis ab.
                    Legen Sie für neue Sprachen die .properties-Datei im selben Ordner ab. Benennen Sie sie in der Standardkonvention. z.B. "ui_strings_de.properties" für deutsch.</p>
                    <table>
                        <tr>
                            <th>Funktion</th>
                            <th>Schnittstelle</th>
                        </tr>
                        <tr>
                            <td>Importieren</td>
                            <td>addtool.io.ADDImport.java</td>
                        </tr>
                        <tr>
                            <td>Exportieren</td>
                            <td>addtool.io.ADDExport.java</td>
                        </tr>
                        <tr>
                            <td>Analyse im Analyse-Tab</td>
                            <td>addtool.analysisonadd.PrintableVisitor.java</td>
                        </tr>
                        <tr>
                            <td>Modell-Feedback</td>
                            <td>addtool.feedback.FeedbackGenerator.java</td>
                        </tr>
                        <tr>
                            <td>Model-Checker-Verbindung</td>
                            <td>addtool.nui.checking.CheckerAdapter.java</td>
                        </tr>
                    </table>
                    <p>Um eigene Einstellungen hinzuzufügen, verwenden Sie die Funktionen des addtool.helpers.preferences.PreferenceManager.</p>
            </section>

        <section class="js-section">
            <h2 class="section__title">Bibliotheken</h2>
            <p>QuADTool ist vollgepackt mit allen notwendigen Abhängigkeiten. Eine vollständige Liste finden Sie in der license.txt im Git-Repository.</p>
        </section>
    </article>
</div>

<footer class="footer">Scribbler is a free HTML template created exclusively for <a href="https://tympanus.net/codrops/"
                                                                                    target="_blank"
                                                                                    class="link link--light">Codrops</a>.
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad();</script>
<script src="scribbler.js"></script>
</body>
</html>